var ActiveModal = (function () {
    /**
     * @param {?} instance
     * @param {?} componentRef
     */
    function ActiveModal(instance, componentRef) {
        var _this = this;
        this._config = instance;
        this._componentRef = componentRef;
        // Automatically destroy the modal component when it has been dismissed.
        this.component.onDismiss.subscribe(function () { return _this._componentRef.destroy(); });
    }
    Object.defineProperty(ActiveModal.prototype, "component", {
        /**
         * @return {?}
         */
        get: function () {
            return this._componentRef.instance;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} callback
     * @return {?}
     */
    ActiveModal.prototype.onApprove = function (callback) {
        this.component.onApprove.subscribe(function (res) { return callback(res); });
        return this;
    };
    /**
     * @param {?} callback
     * @return {?}
     */
    ActiveModal.prototype.onDeny = function (callback) {
        this.component.onDeny.subscribe(function (res) { return callback(res); });
        return this;
    };
    /**
     * @param {?} result
     * @return {?}
     */
    ActiveModal.prototype.approve = function (result) {
        this.component.approve(result);
    };
    /**
     * @param {?} result
     * @return {?}
     */
    ActiveModal.prototype.deny = function (result) {
        this.component.deny(result);
    };
    /**
     * @return {?}
     */
    ActiveModal.prototype.destroy = function () {
        this._componentRef.destroy();
    };
    return ActiveModal;
}());
export { ActiveModal };
function ActiveModal_tsickle_Closure_declarations() {
    /** @type {?} */
    ActiveModal.prototype._config;
    /** @type {?} */
    ActiveModal.prototype._componentRef;
}
//# sourceMappingURL=active-modal.js.map