import { ModalTemplate } from './modal-template';
export declare type ModalSize = "small" | "normal" | "large";
export declare const ModalSize: {
    Small: ModalSize;
    Normal: ModalSize;
    Large: ModalSize;
};
export declare class ModalConfig<T, U = null, V = null> {
    isClosable: boolean;
    closeResult: V;
    context: T;
    size: ModalSize;
    isFullScreen: boolean;
    isBasic: boolean;
    transition: string;
    transitionDuration: number;
    constructor(context?: T, isClosable?: boolean);
}
export declare class TemplateModalConfig<T, U = null, V = null> extends ModalConfig<T, U, V> {
    template: ModalTemplate<T, U, V>;
    constructor(template: ModalTemplate<T, U, V>, context?: T, isClosable?: boolean);
}
export declare class ComponentModalConfig<T, U = null, V = null> extends ModalConfig<T, U, V> {
    component: Function;
    constructor(component: Function, context?: T, isClosable?: boolean);
}
