var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
export var /** @type {?} */ ModalSize = {
    Small: /** @type {?} */ ("small"),
    Normal: /** @type {?} */ ("normal"),
    Large: /** @type {?} */ ("large")
};
var ModalConfig = (function () {
    /**
     * @param {?=} context
     * @param {?=} isClosable
     */
    function ModalConfig(context, isClosable) {
        if (context === void 0) { context = null; }
        if (isClosable === void 0) { isClosable = true; }
        // Initialise with default values.
        this.isClosable = isClosable;
        this.context = context;
        this.size = ModalSize.Normal;
        this.isFullScreen = false;
        this.isBasic = false;
        this.transition = "scale";
        this.transitionDuration = 500;
    }
    return ModalConfig;
}());
export { ModalConfig };
function ModalConfig_tsickle_Closure_declarations() {
    /** @type {?} */
    ModalConfig.prototype.isClosable;
    /** @type {?} */
    ModalConfig.prototype.closeResult;
    /** @type {?} */
    ModalConfig.prototype.context;
    /** @type {?} */
    ModalConfig.prototype.size;
    /** @type {?} */
    ModalConfig.prototype.isFullScreen;
    /** @type {?} */
    ModalConfig.prototype.isBasic;
    /** @type {?} */
    ModalConfig.prototype.transition;
    /** @type {?} */
    ModalConfig.prototype.transitionDuration;
}
var TemplateModalConfig = (function (_super) {
    __extends(TemplateModalConfig, _super);
    /**
     * @param {?} template
     * @param {?=} context
     * @param {?=} isClosable
     */
    function TemplateModalConfig(template, context, isClosable) {
        if (context === void 0) { context = null; }
        if (isClosable === void 0) { isClosable = true; }
        var _this = _super.call(this, context, isClosable) || this;
        _this.template = template;
        return _this;
    }
    return TemplateModalConfig;
}(ModalConfig));
export { TemplateModalConfig };
function TemplateModalConfig_tsickle_Closure_declarations() {
    /** @type {?} */
    TemplateModalConfig.prototype.template;
}
var ComponentModalConfig = (function (_super) {
    __extends(ComponentModalConfig, _super);
    /**
     * @param {?} component
     * @param {?=} context
     * @param {?=} isClosable
     */
    function ComponentModalConfig(component, context, isClosable) {
        if (context === void 0) { context = null; }
        if (isClosable === void 0) { isClosable = true; }
        var _this = _super.call(this, context, isClosable) || this;
        _this.component = component;
        return _this;
    }
    return ComponentModalConfig;
}(ModalConfig));
export { ComponentModalConfig };
function ComponentModalConfig_tsickle_Closure_declarations() {
    /** @type {?} */
    ComponentModalConfig.prototype.component;
}
//# sourceMappingURL=modal-config.js.map