import { OnInit, Renderer2, EventEmitter, ViewContainerRef, AfterViewInit } from '@angular/core';
import { TransitionController } from '../transition/transition-controller';
import { ModalControls } from './modal-controls';
import { ModalConfig, ModalSize } from './modal-config';
export declare class SuiModal<T, U> implements OnInit, AfterViewInit {
    private _renderer;
    isClosable: boolean;
    closeResult: U;
    controls: ModalControls<T, U>;
    readonly approve: (result: T) => void;
    readonly deny: (result: U) => void;
    onApprove: EventEmitter<T>;
    onDeny: EventEmitter<U>;
    onDismiss: EventEmitter<void>;
    private _modalElement;
    size: ModalSize;
    private _isFullScreen;
    isFullScreen: boolean;
    isBasic: boolean;
    transitionController: TransitionController;
    transition: string;
    transitionDuration: number;
    dimBackground: boolean;
    private _isClosing;
    templateSibling: ViewContainerRef;
    constructor(_renderer: Renderer2);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadConfig<V>(config: ModalConfig<V, T, U>): void;
    private dismiss(callback?);
    close(): void;
    onKeyup(e: KeyboardEvent): void;
}
