import { ElementRef, ComponentFactoryResolver, ViewContainerRef, TemplateRef } from '@angular/core';
import { SuiPopup } from './popup';
import { PositioningPlacement } from '../util/positioning.service';
import { TemplateRefContext } from '../util/util';
import { PopupConfig, PopupTrigger } from './popup-config';
import { SuiPopupConfig } from './popup.service';
export interface IPopup {
    open(): void;
    close(): void;
    toggle(): void;
}
export declare class SuiPopupDirective implements IPopup {
    private _element;
    private _viewContainerRef;
    private _componentFactoryResolver;
    config: PopupConfig;
    popupTemplate: TemplateRef<TemplateRefContext<SuiPopup>>;
    popupHeader: string;
    popupText: string;
    popupInverted: boolean;
    popupBasic: boolean;
    popupTransition: string;
    popupTransitionDuration: number;
    popupPlacement: PositioningPlacement;
    popupDelay: number;
    popupTrigger: PopupTrigger;
    popupConfig: PopupConfig;
    private _componentRef;
    private readonly _popup;
    private _openingTimeout;
    constructor(_element: ElementRef, _viewContainerRef: ViewContainerRef, _componentFactoryResolver: ComponentFactoryResolver, popupDefaults: SuiPopupConfig);
    open(): void;
    close(): void;
    toggle(): void;
    private onMouseEnter();
    private onMouseLeave();
    private onClick();
    onDocumentClick(e: MouseEvent): void;
    private onFocus();
    private onFocusOut();
}
